import axios from 'axios';
import React, { useEffect } from 'react';
import { useSetRecoilState } from 'recoil';
import './App.css';
import Filter from './Components/Filter';
import NewTask from './Components/NewTask';
import TodoList from './Components/TodoList';
import { Todo } from './Models/Todo';
import { todoListAtom } from './State/Atom';


function App() {
  const setTodoList = useSetRecoilState(todoListAtom);

  //TODO: initialize the Atom from values on backend -- http://localhost:4000/todos?owner=user1
  //TODO: optionally add loading and error handling
  useEffect(() => {
    axios.get<Todo[]>(`http://localhost:4000/todos?owner=user1`).then(todos => setTodoList(todos.data));
  }, []);

  // TODO: add more children as you complete them
  return (
    <div className="App">
      <h1>Todo List Example</h1>
      <NewTask />
      <Filter />
      <TodoList />
    </div>

  );
}

export default App;
