import React, {useState} from 'react'
import '../App.css';

import {useRecoilRefresher_UNSTABLE, useSetRecoilState} from "recoil";
import { todoListAtom } from "../State/Atom";
import axios from "axios";


export default function NewTask() {
  //TODO hookup NewTask
  // you need to create new todo and and amend the state of the atom
  // do not worry about id and set owner to "user1"
  const [newTodo, setNewTodo] = useState("");
  const setTodoList = useSetRecoilState(todoListAtom);

  const addTodo = () => {
    if (newTodo.length !== 0) {
      const newTodoObj = {todo: newTodo, isDone: false, owner: "user1"};
      // TODO optional - save new todo to db
      // lecturer note: how would proper asynchronous function look like (errors, loading, mention suspense and boundary)
      // lecturer note: the id gets assigned in db, but not on the client, how would you bring the app back in sync (useRecoilRefresher)
      axios.post('http://localhost:4000/todos', newTodoObj);

      // TODO save todo on client
      setTodoList((todos) => [...todos, newTodoObj]);
    }
    setNewTodo("");
  }
    return (
        <div className="new-todo-area">
        <input className="add-new-todo" value = { newTodo } onChange={ (e) => setNewTodo(e.target.value) } placeholder="New Task"/>
        <div className="add-new-todo-button" onClick={() => addTodo()}>Add</div>
      </div>
    )
}
