import React from "react";
import "../App.css";

import { useRecoilState, useRecoilValue } from "recoil";

import { todoListAtom } from "../State/Atom";
import { todoListSelector } from "../State/Selector";
import { Todo } from "../Models/Todo";

interface TodoItemProps {
    item: Todo;
}

export default function TodoItem({ item }: TodoItemProps) {
  // TODO 2: in second stage add handling for (un)completing and deleting the todo
  const [todoList, setTodoList] = useRecoilState(todoListAtom);

  const doneClickEvent = () => {
    const todos = todoList.filter(todo => todo.id !== item.id);
    let newTodo = {...item}
    newTodo.isDone = !newTodo.isDone
    setTodoList([...todos, newTodo]);
  };

  const deleteClickEvent = () => {
    let todos = [...todoList];
    todos = todos.filter(todo => todo.id !== item.id);
    setTodoList(todos);
  };

  // TODO: add a div, checkbox and span and render the values from props
  // you need "todo-item" and "item-name" classnames
  return (
    <div
      className={`todo-item ${item.id === 0 && "list-top-item"}`}>
      <input
        name="isDone"
        type="checkbox"
        className="todo-checkbox"
        onClick={doneClickEvent}
        defaultChecked={item.isDone}
      />
      <span
        className="item-name"
        style={item.isDone ? { textDecoration: "line-through" } : {}}
      >
        {item.todo}
      </span>
      <div className="item-delete" onClick={deleteClickEvent}>
        Delete
      </div>
    </div>
  );
}
