import axios from "axios";
import { AtomEffect } from "recoil";
import { Todo } from "../Models/Todo";

export const DBEffect = (key: string): AtomEffect<Todo[]> => ({setSelf, onSet, trigger}) => {
    // If there's a persisted value - set it on load
    const loadPersisted = async () => {
      const savedValue = await axios.get<Todo[]>(`http://localhost:4000/todos?owner=${key}`);
  
      if (savedValue != null) {
        setSelf(savedValue.data);
      }
    };
  
    // Asynchronously set the persisted data
    if (trigger === 'get') {
      loadPersisted();
    }
  
    // Subscribe to state changes and persist them to localForage
    onSet((newValue, oldValue, isReset) => {
      //optional todo - persist the state in effect
    });
  };
  