import { selector } from "recoil";
import { todoListAtom, filterAtom } from "./Atom";
import {Todo} from "../Models/Todo";


// TODO: add todoListSelector
// possible values should be "all", "completed" and "uncompleted"
// return filtered list based on the filter value
// see lecture slides if you are stuck
export const todoListSelector = selector({
    key: "todoListSelector",
    get: ({ get }) => {
      const list = get(todoListAtom);
      const filter = get(filterAtom);

      switch (filter) {
        case "completed":
          return list.filter((item) => item.isDone);
        case "uncompleted":
          return list.filter((item) => !item.isDone);
        default:
          // all
          return list;
      }
    },
});
